#include <stdio.h>
#include "my_func.c"

#define N 5       // pocet prvkov
#define MIN_VAL 1 // minimalne nahodne cislo
#define MAX_VAL 9 // maximalne nahodne cislo

struct list {
  struct list *left;	
  unsigned val;
  struct list *right;
};

struct list prvy; // prvy clen zoznamu (NULL)

void zadanie(char *meno_programu);
void novyprvok(int *val);
void vypis(void);


int main(int argc, char **argv)
{
  int n=5;
  int *c; // smernik na jednorozmernu maticu n nahodnych cisel
  int i;

  zadanie(argv[0]);

  /* prazdny zoznam */
  prvy.left=NULL;
  prvy.val=0;
  prvy.right=NULL;

  /* ak bolo zadane aj prirodzene cislo n */
  if (argc>1) n=atoi(argv[1]);
 
  /* osetrenie divnych parametrov */
  if (n<2) n=N;

  /* n nahodnych cisel do linearneho zoznamu */
  c=malloc(sizeof(int)*n);
  create_matrix_random_i(c, 1, n, MIN_VAL, MAX_VAL);
  printf("Random Matrix:\n");
  for (i=0; i<n; i++) {
    novyprvok(c+i);
    printf("%i, ", *(c+i));
  }
  printf("\n");
  
  vypis();
  return(0);
}


/* funkcia vytvori novy prvok linearneho zoznamu */
void novyprvok(int *val)
{
  struct list *prvok; // novy vlozeny prvok
  static struct list *prvy_tmp=&prvy; // static local predposledny prvok

  prvok=malloc(sizeof(prvy));

  /* prvky su vkladane na koniec zoznamu (zprava) */

  prvy_tmp->right=prvok;

  *prvok=*prvy_tmp;
  
  prvok->left  = prvy_tmp;
  prvok->val   = *val;
  prvok->right = NULL;

  prvy_tmp=prvok;

  return;
}


/* vypis linearneho zoznamu a pocet prvkov */
void vypis(void)
{
  struct list *prvy_tmp; // lokalna struktura
  register i=0;

  printf("\nLinearny zoznam:\n");

  prvy_tmp=prvy.right;

  while (prvy_tmp->right) {
    printf("%i, ", prvy_tmp->val);
    prvy_tmp=prvy_tmp->right;
    i++;
  }

  printf("%i, ", prvy_tmp->val); i++;
  printf("%i, ", prvy_tmp->val); i++;
  
  prvy_tmp=prvy_tmp->left;
  
  while (prvy_tmp->left) {
    printf("%i, ", prvy_tmp->val);
    prvy_tmp=prvy_tmp->left;
    i++;
  }

  printf("\n\nPostupnost a1,a2...an,an,an-1...a1 pre n=%i", i/2);
  printf("\nPocet clenov postupnosti: %i\n\n", i);
  return;
}


/* funkcia vypise text ulohy */
void zadanie(char *meno_programu)
{
  printf("\nUloha 08: Postupnost a1,a2...an,an,an-1...a1 pomocou obojsmerneho linearneho zoznamu");
  printf("\n          Pre prirodzene cislo n=5 a nahodne prirodzene cisla a1...an");
  printf("\n          Prirodzene cislo (najmenej 2) mozno zadat ako parameter");
  printf("\nPriklad : %s 7\n\n", meno_programu);
  return;
}
