#include <stdio.h>
#include "my_func.c"

#define N 5           // pocet prvkov
#define MIN_VAL -9.9  // minimalne nahodne cislo
#define MAX_VAL 9.9   // maximalne nahodne cislo

struct list {
  struct list *left;	
  float val;
  struct list *right;
};

struct list prvy; // prvy clen zoznamu (NULL)

void zadanie(char *meno_programu);
void novyprvok(float *val);
void vypis(void);


int main(int argc, char **argv)
{
  int n=5;
  float *c; // smernik na jednorozmernu maticu n nahodnych cisel
  int i;

  zadanie(argv[0]);

  /* prazdny zoznam */
  prvy.left=NULL;
  prvy.val=MIN_VAL;
  prvy.right=NULL;

  /* ak bolo zadane aj prirodzene cislo n */
  if (argc>1) n=atoi(argv[1]);
 
  /* osetrenie divnych parametrov */
  if (n<2) n=N;

  /* n nahodnych cisel do linearneho zoznamu */
  c=malloc(sizeof(float)*n);
  create_matrix_random_f(c, 1, n, MIN_VAL, MAX_VAL);
  printf("Random Matrix:   ");
  for (i=0; i<n; i++) {
    novyprvok(c+i);
    printf("%.3f, ", *(c+i)); 
  }
  
  vypis();
  return(0);
}


/* funkcia vytvori novy prvok linearneho zoznamu */
void novyprvok(float *val)
{
  struct list *prvok;    // novy vlozeny prvok
  struct list *prvy_tmp; // local struct (prvok pred ktory treba vlozit hodnotu)

  prvok=malloc(sizeof(prvy));
  prvy_tmp=&prvy;

  /* prvky su vkladane radenim do zoznamu */

  if (prvy_tmp->val>*val) {
    prvok->right = prvy.right;
    prvok->val   = prvy.val;
    prvok->left  = &prvy;
    prvy.right   = prvok;
    prvy.val     = *val;
    prvy.left    = prvok->left;
    prvy         = *prvy_tmp;
  }
  else {
    while ((prvy_tmp->right)&&(prvy_tmp->right->val<*val)) {
      prvy_tmp=prvy_tmp->right;
    }
    prvok->right    = prvy_tmp->right;
    prvok->val      = prvy_tmp->val;
    prvok->left     = prvy_tmp;
    prvy_tmp->right = prvok;
    prvy_tmp->val   = *val;
    prvy_tmp->left  = prvok->left;
  }
  
  return;
}


/* vypis linearneho zoznamu */
void vypis(void)
{
  struct list *prvy_tmp; // lokalna struktura
  register i=0;

  prvy_tmp=&prvy;
  printf("\nLinearny zoznam: ");
  while (prvy_tmp->right) {
    printf("%.3f, ", prvy_tmp->val);
    prvy_tmp=prvy_tmp->right;
    i++;
  }

  printf("\n\n");	
  return;
}


/* funkcia vypise text ulohy */
void zadanie(char *meno_programu)
{
  printf("\nUloha 13: Usporiadana postupnost cisel pomocou obojsmerneho linearneho zoznamu"); 
  printf("\n          z postupnosti a1,a2...an");
  printf("\n          pre prirodzene cislo n=5 a nahodne realne cisla a1...an");
  printf("\n          Prirodzene cislo (najmenej 2) mozno zadat ako parameter");
  printf("\nPriklad : %s 7\n\n", meno_programu);
  return;
}
