#include <stdio.h>
#include <string.h> // strcmp()
#include <stdlib.h> // atoi()

#define MAX 1024

char *file_name_in="cisla.txt";
char *file_name_out="cisla_selectsort.txt";

void zadanie(char *meno_programu);
void select_sort(int *pole, int pocet);

int main(int argc, char **argv)
{
  FILE *file_in, *file_out;
  int pole[MAX];
  char cislo_str[32];
  int cislo, pocet, i;
	  
  zadanie(argv[0]);

  /* ak boli zadane aj nazvy suborov */
  if (argc>1) file_name_in=argv[1];
  if (argc>2) file_name_out=argv[2];
 
  /* osetrenie existencie in suboru pre citanie */
  if (!(file_in=fopen(file_name_in, "r"))) {
    printf("Chyba pri citani suboru %s\n", file_name_in);
    return(-1);
  }

  /* osetrenie realnosti zapisu do suboru out */
  if (!(file_out=fopen(file_name_out, "w"))) {
    printf("Chyba pri zapise do suboru %s\n", file_name_out);
    return(-1);
  }

  for (i=0; i<MAX; i++) pole[i]=0;

  
  /* nacitanie zo suboru */
  i=0;
  printf("Subor %s:\n", file_name_in);
  while ((!feof(file_in))&&(i<MAX)) {
    strcmp(cislo_str, ""); 
    fscanf(file_in, "%s", cislo_str);
    cislo=atoi(cislo_str); 
    printf("%i, ", cislo);
    pole[i]=cislo;
    i++;

  }
  pocet=i;

  /* triedime */
  select_sort(pole, pocet);
  
  /* zapis do suboru */
  printf("\n\nSubor %s:\n", file_name_out);
  for (i=0; i<pocet; i++) {
    fprintf(file_out, "%i, ", pole[i]);
    fprintf(stdout, "%i, ", pole[i]);
  }     

  printf("\n\nUloha splnena v poriadku\n\n");
  fclose(file_in);
  fclose(file_out);
  return(0);
}


/* triedenie */
void select_sort(int *pole, int pocet)
{
  register i, begin, min, index_min, p;

  begin=0;
  index_min=begin;
  min=pole[index_min];

  while (begin<pocet) {
    for (i=begin; i<pocet; i++) { // najde minimum
      if (pole[i]<min) { 
        min=pole[i];
        index_min=i;
      }
    }
    if (begin!=index_min) {       // vymeni zaciatok za minimum
      p=pole[index_min];
      pole[index_min]=pole[begin];
      pole[begin]=p;
    }
    begin++;
    index_min=begin;
    min=pole[index_min];
  }

  return;   
}


/* funkcia vypise text ulohy */
void zadanie(char *meno_programu)
{
  printf("\nUloha 18: Int cisla zo suboru %s (max %i) su triedene do suboru %s", file_name_in, MAX, file_name_out);
  printf("\n          VYBEROM (Select Sort)");
  printf("\n          Mena inych suborov mozno zadat ako parametre");
  printf("\nPriklad : %s in.txt out.txt \n\n", meno_programu);

  return;
}
